[PATCH] git-merge-one-file-script cleanups from Cogito
[git.git] / git-merge-one-file-script
index 3fb43cc..73e1c50 100755 (executable)
@@ -1,6 +1,8 @@
 #!/bin/sh
 #
-# This is the git merge script, called with
+# Copyright (c) Linus Torvalds, 2005
+#
+# This is the git per-file merge script, called with
 #
 #   $1 - original file SHA1 (or empty)
 #   $2 - file in branch1 SHA1 (or empty)
 #
 # Handle some trivial cases.. The _really_ trivial cases have
 # been handled already by git-read-tree, but that one doesn't
-# do any merges that migth change the tree layout.
+# do any merges that might change the tree layout.
 
 case "${1:-.}${2:-.}${3:-.}" in
 #
 # Deleted in both.
 #
 "$1..")
-       echo "ERROR: $4 is removed in both branches."
-       echo "ERROR: This is a potential rename conflict."
-       exit 1;;
+       echo "WARNING: $4 is removed in both branches."
+       echo "WARNING: This is a potential rename conflict."
+       exec git-update-cache --remove -- "$4"
+       ;;
+
 #
 # Deleted in one and unchanged in the other.
 #
-"$1.." | "$1.$1" | "$1$1.")
+"$1.$1" | "$1$1.")
        echo "Removing $4"
-       exec git-update-cache --force-remove "$4" ;;
+       exec rm -f -- "$4" &&
+               git-update-cache --remove -- "$4"
+       ;;
+
 #
 # Added in one.
 #
 ".$2." | "..$3" )
        case "$6$7" in *7??) mode=+x;; *) mode=-x;; esac
        echo "Adding $4 with perm $mode."
-       exec git-update-cache --add --cacheinfo "$6$7" "$2$3" "$4" ;;
+       exec git-cat-file blob "$2$3" >"$4" &&
+               chmod $mode -- "$4" &&
+               git-update-cache --add -- "$4"
+       ;;
+
 #
 # Added in both (check for same permissions).
 #
@@ -46,29 +57,43 @@ case "${1:-.}${2:-.}${3:-.}" in
        fi
        case "$6" in *7??) mode=+x;; *) mode=-x;; esac
        echo "Adding $4 with perm $mode"
-       exec git-update-cache --add --cacheinfo "$6" "$2" "$4" ;;
+       exec git-cat-file blob "$2" >"$4" &&
+               chmod $mode -- "$4" &&
+               git-update-cache --add -- "$4"
+       ;;
+
 #
 # Modified in both, but differently.
 #
 "$1$2$3")
        echo "Auto-merging $4."
-       orig=$(git-unpack-file $1)
-       src1=$(git-unpack-file $2)
-       src2=$(git-unpack-file $3)
-       merge "$src2" "$orig" "$src1"
+       orig=`git-unpack-file $1`
+       src1=`git-unpack-file $2`
+       src2=`git-unpack-file $3`
+
+       merge -p "$src1" "$orig" "$src2" > "$4"
        ret=$?
+       rm -f -- "$orig" "$src1" "$src2"
+
        if [ "$6" != "$7" ]; then
-               echo "ERROR: Permissions $5->$6->$7 don't match."
+               echo "ERROR: Permissions conflict: $5->$6,$7."
+               ret=1
        fi
+       case "$6" in *7??) mode=+x;; *) mode=-x;; esac
+       chmod "$mode" "$4"
+
        if [ $ret -ne 0 ]; then
-               echo "ERROR: Leaving conflict merge in $src2."
+               # Reset the index to the first branch, making
+               # git-diff-file useful
+               git-update-cache --add --cacheinfo "$6" "$2" "$4"
+               echo "ERROR: Merge conflict in $4."
                exit 1
        fi
-       sha1=$(git-write-blob "$src2") || {
-               echo "ERROR: Leaving conflict merge in $src2."
-       }
-       exec git-update-cache --add --cacheinfo "$6" $sha1 "$4" ;;
+       exec git-update-cache --add -- "$4"
+       ;;
+
 *)
-       echo "ERROR: Not handling case $4: $1 -> $2 -> $3" ;;
+       echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
+       ;;
 esac
 exit 1